
    var app_version = '1.0.9'; // ta na db 1.0.6
    var app_store_name = 'com.cinema.primepass';

    var myApp = angular.module('myApp', ['ngMaterial', 'ngAnimate', 'ngRoute','angularLazyImg','ngAria','base64','angular-google-analytics','ngCookies','youtube-embed','snap','slick']);

    myApp.constant('base_url','https://app.primepass.club');
    // myApp.constant('base_url','http://-primepass-dev-mfbasso737064.codeanyapp.com:8080/');

    myApp.config(function ($httpProvider,snapRemoteProvider) {        
         $httpProvider.interceptors.push(function ($q) {
            
            $httpProvider.defaults.withCredentials = true;            

            return {
                 request: function (config) {
                     if(config.url.match(/^(http|https)\:\/\/app.primepass.club\/.*/i)) { //trocar isso em prod
                     // if(config.url.match(/^(http|https)\:\/\/-primepass-dev-mfbasso737064.codeanyapp.com:8080\/.*/i)) { //trocar isso em prod
                         config.params = config.params || {};
                         config.headers['appVersion'] = app_version;

                        if(localStorage.getItem("auth")) {
                            config.headers['Authorization'] = localStorage.getItem('auth');
                            if(localStorage.getItem('deviceInfo')){                                
                                var deviceInfo = JSON.parse(localStorage.getItem('deviceInfo')).device_uuid;
                                config.headers['Device'] = deviceInfo;
                            }
                        }
                    }
                    return config || $q.when(config);                    
                }
             }
         });

        // disable left drag snap        
        snapRemoteProvider.globalOptions = {
            disable: 'left',
            addBodyClasses: true,
            minDragDistance: 2,
            tapToClose: true,
        }      
     });

    myApp.config(function($sceDelegateProvider) {
        $sceDelegateProvider.resourceUrlWhitelist(['self','https://app.primepass.club/**']);
    });

    myApp.config(function (AnalyticsProvider) {
        AnalyticsProvider.setAccount('UA-55376122-2');
        AnalyticsProvider.setHybridMobileSupport(false);
        AnalyticsProvider.enterDebugMode(false); 
        AnalyticsProvider.readFromRoute(true);

    });
    /*
     * Diretiva de execução do app
    */
    myApp.run(function($rootScope, $http, $q, user, $location, base_url, Analytics, $cookies, $window) {
        $rootScope.online = navigator.onLine;
        document.addEventListener("deviceReady", onOnline, false);

        function onOnline() {
            $window.addEventListener("offline", function() {
                localStorage.setItem('status',false);
                // alert('offline');
                $rootScope.$apply(function() {
                    $rootScope.online = false;
                    console.log('offline');             
                });
            }, false);

            $window.addEventListener("online", function() {
                // alert('online');
                localStorage.setItem('status',true); 
                $rootScope.$apply(function() {
                    $rootScope.online = true;
                    // console.log('online');                            
                });
            }, false);
        }        
        /** libera cross-domain **/
        $http.defaults.headers.common['X-CSRFToken'] = $cookies.csrftoken;

        //false var device ready
        $rootScope.deviceReady = false;
        
        $rootScope.snavbar = "";
        $rootScope.iconBack = "";  
        $rootScope.is_log = '';

        $rootScope.estreias = [
        
        
        {
            'name' : 'Estreiando esta Semana',
            'type' : 'Estréias'
        },
        {
            'name' : 'Todos os Filmes',
            'type' : 'Todos os Filmes'
        }

        ];
        
        $rootScope.genres = [

            {
                'eua' : '',
                'br'  : 'Todos os Filmes'
            },
            {
                'eua':'Comédia',
                'br' :'Comédia'
            },
            {
                'eua':'Romance',
                'br' :'Romance'
            },
            {
                'eua':'Drama',
                'br' : 'Drama'
            },
            {
                'eua':'Animação',
                'br' :'Animação'
            },
            {
                'eua':'Ação',
                'br' :'Ação'
            },
            {
                'eua':'Aventura',
                'br' :'Aventura'
            },
            {
                'eua':'Musical',
                'br' :'Musical'
            },
            {
                'eua':'Ficção Científica',
                'br' : 'Ficção Científica'
            },
            {
                'eua':'Suspense',
                'br' : 'Suspense'
            },
            {
                'eua':'Policial',
                'br' : 'Policial'
            },
            {
                'eua':'Faroeste',
                'br' : 'Faroeste'
            },
            {
                'eua':'Guerra',
                'br' : 'Guerra'
            },
        ];           
    });  