
	//webservice de funções do cartão
    // carregar e ver saldo

    myApp.service('card',function($http, base_url) {
        return ({
            getBallance:ballance,
            getRecharge:recharge,
            active:active,
            history: history,
            cardInformation: getCardInformation
        });
        
        function active(cardNumber, userID, password){
            return $http.get(base_url+"/api/cartao/ativar?card="+cardNumber+"&user_id="+userID+"&password="+password)
            .then(function(response){
                return response.data;
            });
        }

        function ballance( userID , sessionID  ){
            return $http.get(base_url+"/api/cartao/saldo?id=" + userID + "&show_id=" + sessionID).then(function(response){
                return response.data;
            });
        }

        function recharge( userID , sessionID ){
            return $http.get(base_url+"/api/cartao/recarga?id=" + userID + "&show_id=" + sessionID).then(function(response){
                return response.data;
            });
        }

        function history(movieName, showID, cinemaName, userID){
            return $http.get(base_url+"/api/cartao/addHistory?movie="+movieName+"&show_id="+showID+"&cinema="+cinemaName+"&user_id="+userID).then(function(response){
                return response.data;
            });
        }

        /**
        * API que retorna dados do cartão de acordo com id do usuário
        */
        function getCardInformation() {
            return $http.post(base_url+"/mobile/api/user/card/info")
            .then(function(response){
                return response.data;
            })
        }
    });

    
    /*
    * Toda api que seja referente a planos    
    **/
    myApp.service('plans', function($http, base_url) {

        return ({
            getPlans: plansList
            
        });


        /**
        * Lista de Planos
        **/
        function plansList() {
            return $http.post(base_url+'/mobile/api/plans')
            .then(function(response){
                return response.data;
            });
        }
    });

    // webservice para trazer toda lista de cinemas
    myApp.service('cinemas',function($http,base_url){

        return ({
            getList:getCinemasList,
            getMetters:getDistance,
            getPosition: geoPositions,
        });
       
        function geoPositions(callback){
            navigator.geolocation.getCurrentPosition(function(pos){ 
                callback(pos);
            },errorPosition);
        }

        // caso haja erros
        function errorPosition(error){
            console.log("Error: "+ error);
        }

        /*
        * Pega posição atual do usuario
        * e faz o calculo da distancia entre ele e o cinema indexado no foreach
        */
         function getDistance( lat , lng, callback ){            
                
            geoPositions(function(pos){
                var userLocation      = new google.maps.LatLng(pos.coords.latitude , pos.coords.longitude);
                var targetLocation    = new google.maps.LatLng(lat, lng);
                var calculateDistance = parseInt(google.maps.geometry.spherical.computeDistanceBetween(userLocation, targetLocation)).toFixed(2);
                
                callback(calculateDistance);
            });                                
                                
        }        
        /*
        *   Caso haja erros
        */
        function errorPosition(err){
             console.warn('ERROR(' + err.code + '): ' + err.message);
        }

        /*
        * Recebe lista dinâmica de todos cinemas
        * retornar desta forma:
        * {name,latitude,longitude,endereço}
        */
        function getCinemasList(lat, lon){
            return $http.get(decodeURI(base_url+"/api/cinemas?lat="+lat+"&lon="+lon)).then(function(response){
                return response; 
            });
        }
    });

    // GoogleMaps latitude service
    myApp.service('maps', function(){

        return ({
            checkDistance: _checkDistance,
        });

        /*
         * Pega a posição atual do usuario
         * Caso nao consiga, chama _error
         * Caso consiga, faz um callback e manda as position
         */
        function getGeoLocation(callback) {
            var options = { timeout: 31000, enableHighAccuracy: true, maximumAge: 90000 };        
            navigator.geolocation.getCurrentPosition(function(positions){
                callback(positions);
            }, _error, options);
        }
        /*
         * Caso haja erros, exibve a mensagem abaixo no console
         */
        function _error(error){
            console.log("Error: "+ error);
        }

        /*
         * Verifica se está na distancia de 100 metros do cinema
         */
        function _checkDistance(targetLat, targetLon, callback){

            // Acessamos a localizaçao do usuario
            getGeoLocation(function(position){
                var userLocation      = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
                var targetLocation    = new google.maps.LatLng(targetLat, targetLon);
                var calculateDistance = parseInt(google.maps.geometry.spherical.computeDistanceBetween(userLocation, targetLocation)).toFixed(2);

                callback(calculateDistance);

            });

        }

    });

    //service to check login to access app
    //
    myApp.service('user',function($http,base_url){

        return ({
            login:getLogin,
            register:getData,            
            history:getListHistory,
            checkMovie:checkMovie,
            loginFB:loginFB,
            checkItAll: check,
            dataUser: encryptData,
            ticket:getTicket,
            status: status,
            token: nfToken,        
        });

        // ----------
        // -- Login
        // ----------
        function getLogin(login, pass, model, platform, device_id, type) {
            console.log(login+pass+model+platform+type);
            return $http.post(base_url+"/mobile/api/auth",{email:login, pass:pass, model:model, platform:platform,deviceID:device_id, type:type}).then(function(response){
                return response.data;
            });
        }

        function getData(name, middlename, email, pass){
            return $http.get(base_url+"/api/user/register?name="+name+"&middlename="+middlename+"&email="+email+"&pass="+pass).then(function(response){
                return response.data;
            });
        }

        function getStatusToWatch(userID) {
            return $http.get(base_url+"/api/user/status?user="+userID).then(function(response){
                return response.data;
            });
        }

        function getListHistory(userID) {
            return $http.get(base_url+"/mobile/api/history?user_id="+userID).then(function(response){
                return response.data;
            });
        }

        function checkMovie(userID, movieName) {
            return $http.get(base_url+"/api/user/movie?user="+userID+"&movie="+movieName).then(function(response){
                return response.data;
            });
        }

        // ----------
        // -- Login Facebook
        // ----------        
        function loginFB(name, middlename, fb, picture, email, accessToken, model, platform, deviceID, type) {
            // alert('aqui');
            // alert(name);
            // alert(middlename);
            // alert(fb);
            // alert(picture);
            // alert(accessToken);
            // alert(type);
            return $http.post(base_url+"/mobile/api/auth",{name:name, middlename:middlename, fb:fb, picture:picture, email:email, accessToken:accessToken, model:model, platform:platform, deviceID:deviceID, type:type})
            .then(function(response){
                return response.data;
            });
        }

        function getTicket(name, middlename, email, message){
            return $http.get(base_url+"/api/tickets/info?message="+message+"&name="+name+"&middlename="+middlename+"&email="+email)
            .then(function(response){
                return response.data;
            });
        }

        function check(){
            var userInfo = JSON.parse(localStorage.getItem('userPrime'));
            var sessionInfo = JSON.parse(sessionStorage.getItem("sessionInformation")); 


            // verifica se o usuario é um pagante
            if(userInfo.paid_user == 'false'){
                answer = {status:'error', message:'Junte-se agora à Primepass, e ative seu passe para acessar ao cinema ilimitado! Acesse www.primepass.club'}
                return answer;                
            }

            if(userInfo.s_allowed_today == 'false'){
                answer = {status:'error', message:'Opa! Seu passe atual é valido de segunda a quarta feira. Faça um upgrade agora e vá ao cinema todos os dias. Quando quiser onde estiver! Acesse www.primepass.club'}
                return answer;
            }

            if(userInfo.plan.is_premium == 0 && sessionInfo.premium == 1){
                answer = {status:'error', message:'Opa! Seu passe atual é valido somente para cinema padrão. Faça um upgrade agora para ter acesso à este e outros cinemas premium. Acesse www.primepass.club'}
                return answer;
            }

            /* 
            * se ele esta logado, e é um pagante, verificamos os tipos de acesso do plano
            */
            
            //verificacao de plano 3d
            if(userInfo.plan.is_3d == 0 && sessionInfo.type == '3D'){
                answer = {status:'error', message:'Opa! Seu passe atual não inclui este tipo de sessão. Escolha outra sessão, ou faça um upgrade agora e aproveite o cinema ao máximo! Acesse www.primepass.club'}
                return answer;
            }

            // verificacao de planos que estao no grupo de especial(macro XE, xplus, xd, kinoevolution, cinepic) 
            // se caso monetizarmos alguma, entao, criamos uma coluna e a verificamos independente das outras
            if(userInfo.plan.is_special == 0 ){
                if(sessionInfo.state == 'Macro XE' || sessionInfo.state == 'XPLUS' || sessionInfo.state == 'XD' || sessionInfo.state == 'KinoEvolution' || sessionInfo.state == 'Cinépic'){
                    answer = {status:'error', message:'Opa! Seu passe atual não inclui salas Especiais. Escolha outra sala, ou faça um upgrade agora e aproveite o cinema ao máximo! Acesse www.primepass.club'}
                    return answer;
                }
            }

            //verificacao de planos que estao no grupo via(d-box,4d,vip, imax)
            if(userInfo.plan.is_vip == 0){
                if(sessionInfo.state == 'D-BOX' || sessionInfo.state == '4D' || sessionInfo.state == 'IMAX' || sessionInfo.state == 'VIP'){
                    answer = {status:'error', message:'Opa! Seu passe atual não inclui salas VIP. Escolha outra sala, ou faça um upgrade agora e aproveite o cinema ao máximo! Acesse www.primepass.club'}
                    return answer;
                }            
            }            
            // if no one return returnar :)

            return {status:'success',message:'Voce pode prosseguir'}
        }

        function encryptData(userID) {
            return $http.get(base_url+"/api/user/again?user_id="+userID).then(function(response){
                return response.data;
            });
        }

        function status(method, session_id, latitude, longitude) {
            return $http.post(base_url+"/mobile/api/session/allow/user",{method: method, session_id:session_id, latitude:latitude, longitude:longitude})
            .then(function(response){
                return response.data;
            });
        }

        /**
        * Verifica token para liberar acesso á pagamento
        **/
        function nfToken() {
            return $http.post(base_url+'/mobile/api/user/get/auth/token')
            .then(function(response){
                return response.data;
            });

        }
    });

    //service to get 
    // all current movie

    myApp.service('movies',function($http,base_url,cinemas){

        return ({
            all:getMovies,
            poster:getPosterMovies,
            sessionsMovieCinema:getshowByMovieCinema,
            banner:bannerMovies,
            soon:getMoviesoon,
            shows:getShows,
            session:getSessionList,
            moviesCinema:getMoviesList,
        });

        function getMovies(movies_id){
            
            if(movies_id == 'theaters'){
                return $http.post(base_url+"/mobile/api/movies",{'typeof':movies_id}).then(function(response){
                    return response.data;
                });
            }else{
               return $http.post(base_url+"/mobile/api/movies",{'typeof':movies_id}).then(function(response){
                    return response.data;
                }); 
            }
            
        }
        // return filmes em cartaz
        function getPosterMovies(){
            return $http.get(base_url+"/api/posterMovies").then(function(response){
                return response.data;
            });
        }   
        // return sessoes de acordo com filme e cinema passados na url
        function getshowByMovieCinema(movie, cinema, latitude, longitude){
            return $http.post(base_url+"/mobile/api/movie/cinema/sessions",{movie_id:movie,cinema_id:cinema, latitude: latitude, longitude: longitude}).then(function(response){
                return response.data;
            });
        }

        function bannerMovies(type){
            return $http.get(base_url+"/api/banners?type="+type).then(function(response){
                return response.data;
            });
        }

         function getMoviesoon(){
            return $http.get(base_url+"/api/moviesSoon").then(function(response){
                return response.data;
            });
        }

        function getShows( movie_id ){

            return $http.get(base_url+"/api/movie/"+movie_id).then(function(response){
                return response.data;
            });
        }

        function getSessionList(id,lat,lon){            
            return $http.post(base_url+"/mobile/api/movie/sessions",
            {movie_id:id, latitude:lat, longitude:lon})
            .then(function(response){
                return response.data;
            });
        }

        function getMoviesList(cinema){
            return $http.post(base_url+"/mobile/api/cinema/movies",{cinema_id:cinema}).then(function(response) {
                return response.data;
            });
        }
    });

    //service to use youtube api
    myApp.service('youtubeAPI',function($window,$q,base_url){
        return({
            showMovie:loadPlayer,
            stopVideo: pauseVideo,
        });

        function getArtistId( id ) {
            return id;
        }

        function loadPlayer( video_id, status) {            
            if (typeof(YT) == 'undefined' || typeof(YT.Player) == 'undefined') {
                //console.log('aqui');
                var tag = document.createElement('script');
                tag.src = "https://www.youtube.com/iframe_api";
                var firstScriptTag = document.getElementsByTagName('script')[0];
                firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);
    
                window.onYouTubePlayerAPIReady = function() {                   
                    onYouTubePlayer( video_id, status );
                };
            }else{
                onYouTubePlayer( video_id );
            }
        }
            

        function onYouTubePlayer( video_id,status) {
          player = new YT.Player('player', {
            height: '220',
            width: '320',
            videoId: getArtistId(video_id),
             playerVars: { 
                theme: 'dark',
                wmode: 'opaque',
                autohide: '1',
                autoplay: '0',
                controls: '1',
                modestbranding: '0',
                disablekb: '0',
                showinfo: '0',
                rel: '0',
            },
            events: {              
              //'onStateChange': onPlayerStateChange,
              'onReady'      : status == 'true' ? onPlayerReady:onPlayerStateChange,
              'onError'      : onPlayerError,
              //'onStateChange': onPlayerStateChange,           
            }
          });
        }

        var player,iframe;
        
        var done = false;

        function onPlayerReady(event){
            event.target.playVideo();
            player.mute();            
        }

        function onPlayerError(e) {
            alert('An error occurred: ' + e.data);
        }

        function onPlayerStateChange(event) {
            if (event.data == YT.PlayerState.PLAYING && !done) {
                stopVideo();
                done = true;
            }
            else if(event.data == YT.PlayerState.ENDED){
                stopVideo();                
            }
        }

        function stopVideo() {
            player.stopVideo();         
        }

        function pauseVideo(){
            player.pauseVideo();
        }
    });

    // ---
    // PRIVATE METHODS.
    // ---
    // I transform the error response, unwrapping the application dta from
    // the API response payload.
    function handleError( response ) {
        console.log('error')

    }
    // I transform the successful response, unwrapping the application data
    // from the API response payload.
    function handleSuccess( response ) {
        return (response.data);
    }

    // GoogleMaps latitude service
    myApp.service('app', function($http,base_url){

        return ({
            getVersion: getVersion
        });


        /*
         * Pega a posição atual do usuario
         * Caso nao consiga, chama _error
         * Caso consiga, faz um callback e manda as position
         */
        function getVersion(platform) {
            return $http.post(base_url+"/api/getlastversionapp",{platform:platform}).then(function(response){
                return response.data;
            });
        }

    });

    myApp.service('accentivHander',function($http,base_url){
        return ({
            sendEmail: emailAccentiv
        });

        function emailAccentiv(userID, sessionID) {
            return $http.post(base_url+"/api/accentivError",userID,sessionID).then(function(response){
                return success;
            });
        }
    });